3504: [Cqoi2014]危桥

3504: [Cqoi2014]危桥

链接

分析:

  首先往返的可以转化为全是“往”,那么只要将容量除以2即可。

  然后S向a1连边容量为an(除以2之前为2*an),S向a2连边容量为an,b1,b2向T连边容量为bn。原图上的边,建双向边保存。

  这样会存在从a1流向b2的流量,当然也有b1流向a2的流量,考虑如何判断这种情况。

  将b1,b2交换,然后重新跑一遍,判断是否满流即可。

  第一遍最大流的时候,假设a1->b2流了x的流量,那么有

  a1->a2:an-x,

  a1->b2:x,

  b1->b2:bn-x

  b1->a2:x

  交换b1和b2之后,一定有

  a1->a2:an-x

  b2->b1:bn-x

  因为这是双向边。那么如果此时仍然满流,说明a1->b1:x,a2可以向b1流x的流量,结合第一个a1可以向b2流x的流量,那么如果将第一次的a1向b2流的流量,流向b1,那么就合法了。

  还有一个小问题,SovietPower提到的。

代码:

#include<cstdio>
#include<algorithm>
#include<cstring>
#include<iostream>
#include<cmath>
#include<cctype>
#include<set>
#include<queue>
#include<vector>
#include<map>
using namespace std;
typedef long long LL;

inline int read() {
    int x=0,f=1;char ch=getchar();for(;!isdigit(ch);ch=getchar())if(ch==‘-‘)f=-1;
    for(;isdigit(ch);ch=getchar())x=x*10+ch-‘0‘;return x*f;
}

const int N = 105, INF = 1e9;
struct Edge{ int to, nxt, cap; } e[10005];
int head[N], dis[N], q[N], cur[N];
char s[N][N];
int En, S, T, n, a1, a2, an, b1, b2, bn;

inline void add_edge(int u,int v,int w) {
    ++En; e[En].to = v, e[En].cap = w, e[En].nxt = head[u]; head[u] = En;
    ++En; e[En].to = u, e[En].cap = 0, e[En].nxt = head[v]; head[v] = En;
}
bool bfs() {
    for (int i = 0; i <= T; ++i) dis[i] = -1, cur[i] = head[i];
    int L = 1, R = 0;
    q[++R] = S, dis[S] = 0;
    while (L <= R) {
        int u = q[L ++];
        for (int i = head[u]; i; i = e[i].nxt) {
            int v = e[i].to;
            if (dis[v] == -1 && e[i].cap > 0) {
                dis[v] = dis[u] + 1;
                q[++R] = v;
                if (v == T) return 1;
            }
        }
    }
    return 0;
}
int dfs(int u,int flow) {
    if (u == T) return flow;
    int used = 0;
    for (int &i = cur[u]; i; i = e[i].nxt) {
        int v = e[i].to;
        if (dis[v] == dis[u] + 1 && e[i].cap > 0) {
            int tmp = dfs(v, min(flow - used, e[i].cap));
            if (tmp > 0) {
                e[i].cap -= tmp, e[i ^ 1].cap += tmp;
                used += tmp;
                if (used == flow) break;
            }
        }
    }
    if (used != flow) dis[u] = -1;
    return used;
}
int dinic() {
    int ans = 0;
    while (bfs()) ans += dfs(S, INF);
    return ans;
}
void build() {
    En = 1; memset(head, 0, sizeof(head));
    add_edge(S, a1, an);add_edge(S, b1, bn);
    add_edge(a2, T, an);add_edge(b2, T, bn);
    for (int i = 1; i <= n; ++i)
        for (int j = i + 1; j <= n; ++j)
            if (s[i][j] == ‘O‘) add_edge(i, j, 1), add_edge(j, i, 1);
            else if (s[i][j] == ‘N‘) add_edge(i, j, INF), add_edge(j, i, INF);
}
void solve() {
    S = 0, T = n + 1;
    a1 = read() + 1, a2 = read() + 1, an = read();
    b1 = read() + 1, b2 = read() + 1, bn = read();
    for (int i = 1; i <= n; ++i) scanf("%s", s[i] + 1);
    build();
    if (dinic() != an + bn) { puts("No"); return ; }
    swap(b1, b2);
    build();
    if (dinic() != an + bn) { puts("No"); return ; }
    puts("Yes");
}
int main() {
    while (~scanf("%d", &n)) solve();
    return 0;
}

原文地址:https://www.cnblogs.com/mjtcn/p/10339497.html

时间: 2024-11-15 14:26:26

3504: [Cqoi2014]危桥的相关文章

bzoj 3504: [Cqoi2014]危桥

1 #include<cstdio> 2 #include<iostream> 3 #include<cstring> 4 #define M 100009 5 #define inf 2139062143 6 using namespace std; 7 int n,a1,a2,an,b1,b2,bn,tot,cnt=1,T,ans,head[M],d[M],q[2*M],next[10*M],u[10*M],v[10*M]; 8 char ch[60][60]; 9

bzoj千题计划137:bzoj [CQOI2014]危桥

http://www.lydsy.com/JudgeOnline/problem.php?id=3504 往返n遍,即单向2*n遍 危桥流量为2,普通桥流量为inf 原图跑一遍最大流 交换b1,b2再跑一遍最大流 如果两次的结果都等于(an+bn)*2 则可以 证明参见http://www.cnblogs.com/chenyushuo/p/5139556.html #include<queue> #include<cstdio> #include<cstring> #i

Luogu3163 [CQOI2014]危桥 ---- 网络流 及 一个细节的解释

Luogu3163 [CQOI2014]危桥 题意 有$n$个点和$m$条边,有些边可以无限次数的走,有些边这辈子只能走两次,给定两个起点和终点$a_1 --> a_2$(起点 --> 终点)和$b_1 --> b_2$(起点 --> 终点),询问是否可以让$a_1 --> a_2$往返$a_n$次,让$b_1 --> b_2$往返$b_n$次 题解 思路 思路还是比较好想的,就是原图连双向边,然后炒鸡源汇连$a_n*2$和$b_n*2$判断满流是否为$(a_n+b_n

【BZOJ 3504】[Cqoi2014]危桥

Description Alice和Bob居住在一个由N座岛屿组成的国家,岛屿被编号为0到N-1.某些岛屿之间有桥相连,桥上的道路是双 向的,但一次只能供一人通行.其中一些桥由于年久失修成为危桥,最多只能通行两次.Alice希望在岛屿al和a2之间往返an次(从al到a2再从a2 到al算一次往返).同时,Bob希望在岛屿bl和b2之间往返bn次.这个过程中,所有危桥最多通行两次,其余的桥可以无限次通行.请问Alice和 Bob能完成他们的愿望吗? Input 本题有多组测试数据. 每组数据第一

P3163 [CQOI2014]危桥

传送门 我是看不出这玩意儿和网络流有什么关系-- 我们把图中的所有边都当成无向边加入图中,容量为\(inf\) 危桥的容量为\(2\) 从源点到\(a1,b1\)连边容量为\(an*2\),\(a2,b2\)到汇点连边容量\(bn*2\),相当于一次把两边都走完 然后跑一遍看看是否满流即可 然而这样会有一个问题,就是最终求得的最大流是\(a1\)流向\(b2\)或\(a2\)流向\(b1\) 于是再从源点向\(a1\)和\(b2\)连边,\(a2\)和\(b1\)向汇点连边,再跑一遍看看是否满流

bzoj3504: [Cqoi2014]危桥--最大流

题目大意:给张无向图,有两个人a,b分别从各自的起点走向各自的终点,走A,B个来回,图里有些边只能走两次,求问是否能满足a,b的需求 按照题目给的表建图 S连a1,b1 a2,b2连T 跑最大流看是否满流 为了防止a1跑到b2的情况 第二遍 S连a1,b2 a2,b1连T 若还是满流说明没问题 1 #include<stdio.h> 2 #include<string.h> 3 #include<algorithm> 4 #include<queue> 5

bzoj3504: [Cqoi2014]危桥 网络流

一种网络流建图的思路吧,改天最好整理一波网络流建图思路 1 #include <bits/stdc++.h> 2 using namespace std; 3 int n,h,t,a1,a2,an,b1,b2,bn,flow,now;char ch; 4 int dis[52],l[52],d[52][52];char c[52][52]; 5 char getch() 6 { 7 for(ch=getchar();ch!='O' && ch!='N' && c

bzoj3504: [Cqoi2014]危桥

题意:给出一个图,有的边可以无限走,有的只能走两次(从一头到另一头为一次),给定两个起点以及对应的终点以及对应要走几个来回,求判断是否能完成. 先来一个NAIVE的建图:直接限制边建为容量1,无限制为INF,按照原图连,然后跑最大流就可以了. 可惜这样还不够,因为有可能有一部分流量不是对应的起点流过来的,即两条路有流量交换,这样就不一定可以满足题意了. 解决方法是:再跑一遍网络流,但是建图要改变一下,即将a路线的起点终点调换一下(当然b也可以),再接着跑,如果仍然满足则是真的有解. 证明看了网上

[Cqoi2014]危桥 (两遍网络流)

题目链接 1 #include <bits/stdc++.h> 2 using namespace std; 3 typedef long long ll; 4 inline int read() 5 { 6 int x=0,f=1;char ch=getchar(); 7 while(ch<'0'||ch>'9'){if(ch=='-')f=-1;ch=getchar();} 8 while(ch>='0'&&ch<='9'){x=x*10+ch-'0